#INCLUDE "ac_htmlhw.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_ac_htmlhw",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_ac_htmlhw_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_ac_htmlhw_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _ac_htmlhw AS _pdm_PlugIn && 
   Name="_ac_htmlhw"

   ID=30000         && ID of Plug-in
   Type="CONV" && Typ of plug-in (group)

   Setting=.NULL.
   Par=.NULL.
   HHC=""


   PROCEDURE GetOutputFile(loSetting,laFile) && Return main output file
      * loSetting - Object of settings
      *@laFile    - Output file (it's array)
      LOCAL loPDM,lcHHP
      loPDM=EVAL(This.PDM)

      lcHHP=loSetting.HHP

      IF !EMPTY(lcHHP)
         lcHHP=IIF(AT("\\",lcHHP)>0 OR AT(":",lcHHP)>0,"",loPDM.OutDir)+lcHHP
      ENDIF
      laFile(1)=ChangeExtensionFromFile(lcHHP,'chm')
      RETURN 1
   ENDPROC

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\ac_"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "HTML Help WorkShop")

         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetHHP, "HHP file")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetHHC, "HHC file")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetHHK, "HHK file")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetHHW, "Workshop EXE")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Plug-in po pevod html soubor do jednoho chm souboru. Jako hostitelsk aplikace se pouv HTML Help Workshop.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lihHHC,lihHHK,llFind,llFirst,llAny,lcComment,liWFS,;
            lcHHP,lcHHC,lcHHK,lcPom,lcLang,liRecno,lcPom,llSeek,lii,liCount,lcPom2,;
            lcDir,lcStartupInfo,lcProcessInfo,loSI,loPI,liDSIS,lcFiles,luCatch,lcFile

      LOCAL ARRAY laFiles(1)

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      liDSIS=This.DataSessionID

      * hhp - folder and name of project
      * hhc - folder and name of context
      * hhk - folder and name of index

      STORE 0 TO lihHHP,lihHHC,lihHHK
      lcHHP=loSetting.HHP
      lcHHC=loSetting.HHC
      lcHHK=loSetting.HHK

      IF !EMPTY(lcHHP)
         lcHHP=IIF(AT("\\",lcHHP)>0 OR AT(":",lcHHP)>0,"",loPDM.OutDir)+lcHHP
      ENDIF
  
      IF !EMPTY(lcHHC)
         STORE IIF(AT("\\",lcHHC)>0 OR AT(":",lcHHC)>0,"",loPDM.OutDir)+lcHHC TO lcHHC,This.HHC
      ENDIF
      IF !EMPTY(lcHHK)
         lcHHK=IIF(AT("\\",lcHHK)>0 OR AT(":",lcHHK)>0,"",loPDM.OutDir)+lcHHK
      ENDIF

      IF !EMPTY(lcHHC)
         lihHHC=poPDMs.FCreate(lcHHC) && Handle opened file
         =IIF(lihHHC>0,.T.,;
               loPDMs.WriteToLogFile(STRTRAN(This.GetString(_PDM_msgFileNC),"%File%",lcHHC)))
      ENDIF
      IF !EMPTY(lcHHK)
         lihHHK=poPDMs.FCreate(lcHHK) && Handle opened file
         =IIF(lihHHK>0,.T.,;
               loPDMs.WriteToLogFile(STRTRAN(This.GetString(_PDM_msgFileNC),"%File%",lcHHK)))
      ENDIF

      IF !EMPTY(lcHHP)
         SET COLLATE TO "MACHINE"
         SET DATASESSION TO (loPDMs.DataSessionID)
         SELE (loPDMs.LangC) && sko na seznam jazyk a nastav jazykov kontext
         lcLang="0x"+RIGHT(TRANSFORM(GetThreadLocale(),"@0"),4)+IIF(SEEK(GetThreadLocale())," "+ALLT(Name),"")

         SET COLLATE TO (loPDMs.Collate)

         lcPom=STRTRAN(loSetting.cHHP,"%CHM%",ChangeExtensionFromFile(ExtractFileFromFile(lcHHP),'chm'))
         lcPom=STRTRAN(lcPom,"%Lang%",lcLang)
         lcPom=STRTRAN(lcPom,"%HHC%",loPDM.PathRelativePathTo(lcHHP,lcHHC))
         lcPom=STRTRAN(lcPom,"%HHK%",loPDM.PathRelativePathTo(lcHHP,lcHHK))
         lcPom=STRTRAN(lcPom,"%MainHtml%",loPDM.PathRelativePathTo(lcHHP,loPDM.OutDir+loPDM.FirstPage))

         SET DATASESSION TO (loPDM.DataSessionID)
         SELE (loPDM.FL)
         lcFiles=""
         SCAN FOR !EMPTY(XX510)
              lcFiles=lcFiles+loPDM.PathRelativePathTo(lcHHP,loPDM.OutDir+XX510)+CRLF
         ENDSCAN

         lcPom2=SYS(2000,loPDM.OutDir+"imgs\*.*")
         DO WHILE LEN(lcPom2)>0
            lcFiles=lcFiles+loPDM.PathRelativePathTo(lcHHP,loPDM.OutDir+"imgs\"+LOWER(lcPom2))+CRLF
            lcPom2=SYS(2000,loPDM.OutDir+"imgs\*.*",1)
         ENDDO

         lcPom2=SYS(2000,loPDM.OutDir+"css\*.*")
         DO WHILE LEN(lcPom2)>0
            lcFiles=lcFiles+loPDM.PathRelativePathTo(lcHHP,loPDM.OutDir+"css\"+LOWER(lcPom2))+CRLF
            lcPom2=SYS(2000,loPDM.OutDir+"css\*.*",1)
         ENDDO

         lcPom2=SYS(2000,loPDM.OutDir+"js\*.*")
         DO WHILE LEN(lcPom2)>0
            lcFiles=lcFiles+loPDM.PathRelativePathTo(lcHHP,loPDM.OutDir+"js\"+LOWER(lcPom2))+CRLF
            lcPom2=SYS(2000,loPDM.OutDir+"js\*.*",1)
         ENDDO

         lcPom2=SYS(2000,loPDM.OutDir+"repository\*.*")
         DO WHILE LEN(lcPom2)>0
            IF INLIST(ExtractExtensionFromFile(lcPom2),"BMP","GIF","JPG","MSK","ICO","CUR","ANI","PNG","JS","CSS")
               lcFiles=lcFiles+loPDM.PathRelativePathTo(lcHHP,loPDM.OutDir+"repository\"+LOWER(lcPom2))+CRLF
            ENDIF
            lcPom2=SYS(2000,loPDM.OutDir+"repository\*.*",1)
         ENDDO

         * Project Overview - soubor - pidat
         IF !EMPTY(m.loPDM.PO._Link)
            lcFiles=lcFiles+m.loPDM.PO._Link+CRLF && loPDM.PathRelativePathTo(lcHHP,m.loPDM.PO._Link)+CRLF
         ENDIF

         lcPom=STRTRAN(lcPom,"%files%",lcFiles)

         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         =STRTOFILE(lcPom,lcHHP)
         =IIF(loPDMs.nErr=0,.T.,;
             loPDMs.WriteToLogFile(STRTRAN(This.GetString(_PDM_msgFileNC),"%File%",lcHHP)))
         =loPDMs.SetCatch(luCatch) && Nastav zachycen chyby
      ENDIF
       

      * Index
      IF lihHHK>0
         lcPom=[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">]+CRLF+;
               [<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="]+loPDMs.CLang+[" lang=]+loPDMs.CLang+[">]+CRLF+;
               [<head>]+CRLF+;
               [ <!-- Sitemap 1.0 -->]+CRLF+;
               [ <meta content="text/html; charset=windows-]+LTRIM(STR(loPDMs.CP,5))+[" http-equiv="Content-Type" />]+CRLF+;
               [ <meta name="Generator" content="Project Documenting Machine" />]+CRLF+;
               [ <meta name="Version" content="]+loPDMs.Version+[" />]+CRLF+;
               [ <title></title>]+CRLF+;
               [</head>]+CRLF+;
               [<body>]+CRLF+;
               [<ul>]+CRLF
         =FPUTS(lihHHK,lcPom)

         SET DATASESSION TO (loPDM.DataSessionID)
         SELE (loPDM.FL)
*         INDEX ON STR(XX000,11)+STR(XX001,11)+STR(XX002,11)+STR(XX003,11) TAG I01 && Index exists !!!!

         * PO - Project overview
         IF SEEK(STR(0,11))
            lcPom=[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+XX506+[">]+CRLF+;
                  [  <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+XX510)+[">]+CRLF+;
                  [ </object>]+CRLF
             =FPUTS(lihHHK,lcPom)
         ENDIF

         * GCT - Global classes tree
         IF SEEK(STR(12,11))
            lcPom=[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+XX506+[">]+CRLF+;
                  [  <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+XX510)+[">]+CRLF+;
                  [ </object>]+CRLF
             =FPUTS(lihHHK,lcPom)
         ENDIF

         * Images
         IF SEEK(STR(9,11)+STR(3,11))
            lcPom=[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+XX506+[">]+CRLF+;
                  [  <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+XX510)+[">]+CRLF+;
                  [ </object>]+CRLF
             =FPUTS(lihHHK,lcPom)
         ENDIF

         * FrP - Friendly Projects
         IF SEEK(STR(11,11))
            lcPom=[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+XX506+[">]+CRLF+;
                  [  <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+XX510)+[">]+CRLF+;
                  [ </object>]+CRLF
             =FPUTS(lihHHK,lcPom)
         ENDIF

         * Find Project
         IF SEEK(STR(1,11))
            lcPom=[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+XX506+[">]+CRLF+;
                  [  <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+XX510)+[">]+CRLF+;
                  [ </object>]+CRLF
            =FPUTS(lihHHK,lcPom)

            liXX000=XX000
            =SEEK(STR(liXX000,11))
            SKIP 1
            lii=0
            SCAN WHILE XX000=liXX000 FOR BITTEST(XX507,_PDM_FG_bPJX) AND !EMPTY(XX510)
                 IF lii=0
                    lii=1
                    lcPom=" <ul>"+CRLF
                 ELSE
                    lcPom=""
                 ENDIF
                 lcPom=lcPom+[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX506+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+XX510)+[">]+CRLF+;
                       [  </object>]+CRLF

                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =IIF(lii=1,FPUTS(lihHHK," </ul>"),.T.)
         ENDIF

         * Find Procedures
         SET DATASESSION TO (loPDMs.DataSessionID)
         SELE (loPDMs.Anchors)
         IF SEEK(STR(0,11)+STR(_PDM_FG_Proced,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_02657)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"

            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_Proced
                 lcFile=loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR)
                 IF FILE(m.lcFile)
                    lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                          [   <param name="Name" value="]+XX006+[">]+CRLF+;
                          [   <param name="Local" value="]+loPDM.PathRelativePathTo(m.lcHHK,m.lcFile)+[">]+CRLF+;
                          [  </object>]+CRLF
                    =FPUTS(lihHHK,lcPom)
                 ENDIF
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Methods
         IF SEEK(STR(0,11)+STR(_PDM_FG_Method,11))
            llFirst=.T.
            llAny=.F.

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_Method
                 lii=RAT(".",XX006)
                 lcComment=LEFT(XX006,lii-1)
                 lcFile=loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR)
                 IF FILE(m.lcFile)
                    IF llFirst
                       llFirst=.F.
                       llAny=.T.

                       lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                           [  <param name="Name" value="]+loPDMs.aStrings(PDM_04835)+[">]+CRLF+;
                           [  <param name="Local" value="about:blank">]+CRLF+;
                           [ </object>]+CRLF+;
                           " <ul>"

                       =FPUTS(lihHHK,lcPom)
                    ENDIF

                    lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                          [   <param name="Name" value="]+IIF(lii=0,XX006,SUBST(XX506,lii+1))+[">]+CRLF+;
                          [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,m.lcFile)+[">]+CRLF+;
                          [   <param name="Comment" value="]+lcComment+[">]+CRLF+;
                          [  </object>]+CRLF
                    =FPUTS(lihHHK,lcPom)
                 ENDIF
            ENDSCAN
            =IIF(llAny,FPUTS(lihHHK," </ul>"+CRLF),.T.)
         ENDIF

         * Find Properties
         IF SEEK(STR(0,11)+STR(_PDM_FG_Property,11))
            llFirst=.T.
            llAny=.F.
            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_Property FOR FILE(loPDM.OutDir+FILE)
                 lcFile=loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR)
                 IF FILE(m.lcFile)
                    IF llFirst
                       llFirst=.F.
                       llAny=.T.

                       lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                             [  <param name="Name" value="]+loPDMs.aStrings(PDM_04791)+[">]+CRLF+;
                             [  <param name="Local" value="about:blank">]+CRLF+;
                             [ </object>]+CRLF+;
                             " <ul>"

                       =FPUTS(lihHHK,lcPom)
                    ENDIF
                    lii=RAT(".",XX006)
                    lcComment=LEFT(XX006,lii-1)

                    lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                          [   <param name="Name" value="]+IIF(lii=0,XX006,SUBST(XX006,lii+1))+[">]+CRLF+;
                          [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,m.lcFile)+[">]+CRLF+;
                          [   <param name="Comment" value="]+lcComment+[">]+CRLF+;
                          [  </object>]+CRLF
                    =FPUTS(lihHHK,lcPom)
                 ENDIF
            ENDSCAN
            =IIF(llAny,FPUTS(lihHHK," </ul>"+CRLF),.T.)
         ENDIF


         * Find Class
         IF SEEK(STR(0,11)+STR(_PDM_FG_Class,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_00486)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"

            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_Class
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF


         * Find objects
         IF SEEK(STR(0,11)+STR(_PDM_FG_Object,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_04921)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"

            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_Object
                 lii=RAT(".",XX006)
                 lcComment=LEFT(XX006,lii-1)

                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+IIF(lii=0,XX006,SUBST(XX006,lii+1))+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [   <param name="Comment" value="]+lcComment+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Database containers
         IF SEEK(STR(0,11)+STR(_PDM_FG_DBC,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_00777)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_DBC
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF


         * Find tables (free/in DBC)
         IF SEEK(STR(0,11)+STR(_PDM_FG_DBF,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_01245)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_DBF
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF


         * Find Views (local & remote)
         IF SEEK(STR(0,11)+STR(_PDM_FG_View,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_01247)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_View
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Connections
         IF SEEK(STR(0,11)+STR(_PDM_FG_Conn,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_01249)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_Conn
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Queries
         IF SEEK(STR(0,11)+STR(_PDM_FG_QPR,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_00781)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_QPR
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find VCX libraries
         IF SEEK(STR(0,11)+STR(_PDM_FG_VCX,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_00174)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_VCX
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF


         * Find Forms
         IF SEEK(STR(0,11)+STR(_PDM_FG_SCX,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_00182)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_SCX
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find programes
         IF SEEK(STR(0,11)+STR(_PDM_FG_PRG,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_02084)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_PRG
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Menus
         IF SEEK(STR(0,11)+STR(_PDM_FG_MNX,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_02385)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_MNX
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Reports
         IF SEEK(STR(0,11)+STR(_PDM_FG_FRX,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_03011)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_FRX
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Labels
         IF SEEK(STR(0,11)+STR(_PDM_FG_LBX,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_04396)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_LBX
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find header files
         IF SEEK(STR(0,11)+STR(_PDM_FG_HPP,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_04633)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_HPP
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Stored Procedures
         IF SEEK(STR(0,11)+STR(_PDM_FG_SP,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_01251)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_SP
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         * Find Events Files
         IF SEEK(STR(0,11)+STR(_PDM_FG_EF,11))
            lcPom=CRLF+[ <li /><object type="text/sitemap">]+CRLF+;
                  [  <param name="Name" value="]+loPDMs.aStrings(PDM_00852)+[">]+CRLF+;
                  [  <param name="Local" value="about:blank">]+CRLF+;
                  [ </object>]+CRLF+;
                  " <ul>"
            =FPUTS(lihHHK,lcPom)

            SCAN WHILE LEN(BFILE)=0 AND XX007=_PDM_FG_EF
                 lcPom=[  <li /><object type="text/sitemap">]+CRLF+;
                       [   <param name="Name" value="]+XX006+[">]+CRLF+;
                       [   <param name="Local" value="]+loPDM.PathRelativePathTo(lcHHK,loPDM.OutDir+FILE+IIF(LEN(ANCHOR)=0,"","#"+ANCHOR))+[">]+CRLF+;
                       [  </object>]+CRLF
                 =FPUTS(lihHHK,lcPom)
            ENDSCAN
            =FPUTS(lihHHK," </ul>"+CRLF)
         ENDIF

         lcPom=[</ul>]+CRLF+;
               [</body>]+CRLF+;
               [</html>]+CRLF
         =FPUTS(lihHHK,lcPom)
      ENDIF

      * Contents
      IF lihHHC>0
         lcPom=[<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">]+CRLF+;
               [<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="]+loPDMs.CLang+[" lang=]+loPDMs.CLang+[">]+CRLF+;
               [<head>]+CRLF+;
               [<!-- Sitemap 1.0 -->]+CRLF+;
               [ <title></title>]+CRLF+;
               [ <meta content="text/html; charset=windows-]+LTRIM(STR(loPDMs.CP,5))+[" http-equiv="Content-Type" />]+CRLF+;
               [ <meta name="Generator" content="Project Documenting Machine" />]+CRLF+;
               [ <meta name="Version" content="]+loPDMs.Version+[" />]+CRLF+;
               [</head>]+CRLF+;
               [<body>]+CRLF+;
               [<ul>]+CRLF
         =FPUTS(lihHHC,lcPom)

         SET DATASESSION TO (loPDM.DataSessionID)
         GO TOP
         This.GenerateContents(lihHHC,;
               IIF(loPDM.One,;
               STR(XX000,11),; && +IIF(XX001>0,STR(XX001,11),"")
               ""),"",.T.)


         lcPom=[</ul>]+CRLF+;
               [</body>]+CRLF+;
               [</html>]+CRLF
         =FPUTS(lihHHC,lcPom)

      ENDIF

      SET DATASESSION TO (liDSIS)

      IF lihHHP>0
         lihHHP=poPDMs.FClose(lihHHP) && Close file
      ENDIF
      IF lihHHC>0
         lihHHC=poPDMs.FClose(lihHHC) && Close file
      ENDIF
      IF lihHHK>0
         lihHHK=poPDMs.FClose(lihHHK) && Close file
      ENDIF



*!*	      IF loSetting.iRunHTMLHW=1 AND !EMPTY(loSetting.HTMLHW) AND FILE(loSetting.HTMLHW)
*!*	         lcDir=loPDM.OutDir+CHR(0)

*!*	         loSI=CREATEOBJECT("_struc_STARTUPINFO")
*!*	         loPI=CREATEOBJECT("_struc_PROCESS_INFORMATION")

*!*	         lcStartupInfo=loSI.CreateString()
*!*	         lcProcessInfo=loPI.CreateString()

*!*	         IF CreateProcess(.NULL., loSetting.HTMLHW, 0, 0, 1,  NORMAL_PRIORITY_CLASS, 0, @lcDir, @lcStartupInfo, @lcProcessInfo)#0
*!*	            * vborn neselhalo to
*!*	            loPI.ReadString(@lcProcessInfo)
*!*	            liWFS=WAIT_TIMEOUT
*!*	            DO WHILE liWFS= WAIT_TIMEOUT
*!*	               liWFS=WaitForSingleObject(loPI.hProcess, 250 )
*!*	            ENDDO
*!*	            =CloseHandle(loPI.hProcess) && uzavi handle
*!*	         ENDIF
*!*	      ENDIF
      RETURN ""
   ENDPROC

   PROCEDURE GenerateContents(liHHC,lcLevel,lcHTML,llFirst) && Generate hcc file
      LOCAL loPDM,lcMacro,liCount,liRecno,liCountX,liLevel,lcSP
      liCount=0
      loPDM=EVAL(This.PDM)
*STR(XX000,11)+STR(XX001,11)+STR(XX002,11)+STR(XX003,11)

      liLevel=LEN(lcLevel)/6
      lcSP=SPACE(liLevel+1)
      IF liLevel=0
         LOCATE FOR XX000>=0 AND XX001=0
         lcMacro="XX000>=0 AND XX001=0"
         llFind=FOUND()
      ELSE
         llFind=SEEK(lcLevel)
         SET KEY TO (lcLevel)
         lcMacro="XX00"+STR(liLevel,1)+"#0 AND XX00"+STR(liLevel+1,1)+"=0"
      ENDIF
      lcMacro="IIF(!llFind AND liLevel=1,.T.,"+lcMacro+")"

      lcHTML=""
      SCAN FOR &lcMacro. AND BITTEST(XX507,0)
           liCount=liCount+1
           lcHTML=lcHTML+;
                  lcSP+[<li /> <object type="text/sitemap">]+CRLF+;
                  lcSP+[ <param name="Name" value="]+XX506+[">]+CRLF+;
                  lcSP+[ <param name="Local" value="]+loPDM.PathRelativePathTo(This.HHC,loPDM.OutDir+XX510)+[">]+CRLF+;
                  lcSP+[</object>]+CRLF
         
           liRecno=RECNO()
           lcPom=""
           liCountX=This.GenerateContents(0,;
                         STR(XX000,6)+IIF(liLevel>=1,STR(XX001,6),"")+;
                         IIF(liLevel>=2,STR(XX002,6),"")+;
                         IIF(liLevel>=3,STR(XX003,6),"")+;
                         IIF(liLevel>=4,STR(XX004,6),"")+;
                         IIF(liLevel>=5,STR(XX005,6),"")+;
                         IIF(liLevel>=6,STR(XX006,6),"")+;
                         IIF(liLevel>=7,STR(XX007,6),"")+;
                         IIF(liLevel>=8,STR(XX008,6),"")+;
                         IIF(liLevel>=9,STR(XX009,6),"");
                         ,@lcPom,.F.)

           SET KEY TO (lcLevel)
           GO (liRecno)

           IF liCountX>0
              lcHTML=lcHTML+;
               lcSP+[<ul>]+CRLF+;
               lcPom+;
               lcSP+[</ul>]+CRLF
           ENDIF

           IF llFirst
              =FWRITE(liHHC,lcHTML)
              lcHTML=""
           ENDIF
      ENDSCAN
      RETURN liCount
   ENDPROC

   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_ac_htmlhw_par")
   ENDPROC


   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.hhp=GetINIString(lcSection,"HHP",loSettings.hhp,254,@lcFile)
      loSettings.hhc=GetINIString(lcSection,"HHC",loSettings.hhc,254,@lcFile)
      loSettings.hhk=GetINIString(lcSection,"HHK",loSettings.hhk,254,@lcFile)

      loSettings.irunhtmlhw=VAL(GetINIString(lcSection,"IRUNHTMLHW",STR(loSettings.irunhtmlhw,1),1,@lcFile))
      loSettings.htmlhw=GetINIString(lcSection,"HTMLHW",loSettings.htmlhw,254,@lcFile)

      lcData=GetINISection(lcSection+"_Default",32000,@lcFile) && Cel sekce
      IF !EMPTY(lcData)
         liCount=ALINES(laPom,STRTRAN(lcData,CHR(0),CHR(13)+CHR(10))) && Nati dky
         lcData=""
         FOR lii=1 TO liCount
             lcData=lcData+SUBST(laPom(lii),2)+CHR(13)+CHR(10)
         NEXT
         IF !EMPTY(lcData)
            loSettings.chhp=lcData
         ENDIF
      ENDIF
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData,liCount,lii
      LOCAL ARRAY laPom(1)
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"HHP",ALLT(loSettings.hhp),@lcFile)
      =WriteINIString(lcSection,"HHC",ALLT(loSettings.hhc),@lcFile)
      =WriteINIString(lcSection,"HHK",ALLT(loSettings.hhk),@lcFile)

      =WriteINIString(lcSection,"IRUNHTMLHW",STR(loSettings.irunhtmlhw,1),@lcFile)
      =WriteINIString(lcSection,"HTMLHW",ALLT(loSettings.htmlhw),@lcFile)

      lcData=""
      liCount=ALINES(laPom,loSettings.chhp) && Nati dky
      FOR lii=1 TO liCount
          lcData=lcData+"="+laPom(lii)+CHR(0)
      NEXT
      =WriteINISection(lcSection+"_Default",@lcData,@lcFile)

      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object
      loDst.chhp=loSrc.chhp
      loDst.hhp=loSrc.hhp
      loDst.hhc=loSrc.hhc
      loDst.hhk=loSrc.hhk
      loDst.irunhtmlhw=loSrc.irunhtmlhw
      loDst.htmlhw=loSrc.htmlhw
   ENDPROC


   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody
      RETURN .T.
   ENDPROC

ENDDEFINE

****************************************************************
DEFINE CLASS _ac_htmlhw_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_ac_htmlhw_par"
   OK=.F.
 
   hhp="test.hhp" && Help project
   hhc="test.hhc" && Help context
   hhk="test.hhk" && Help Index

   chhp="" && Default contents of HHP file

   irunhtmlhw=0 && Run compile HTML Help Wokshop
   htmlhw="" && HTML Help Wokshop EXE

   PROCEDURE Init()
   This.chhp=;
       "[OPTIONS]"+CRLF+;
       [Auto Index=Yes]+CRLF+;
       [Binary TOC=Yes]+CRLF+;
       [Compatibility=1.1 or later]+CRLF+;
       [Compiled file=%CHM%]+CRLF+;
       [Contents file=%HHC%]+CRLF+;
       [Create CHI file=Yes]+CRLF+;
       [Default Window=Faworites]+CRLF+;
       [Default topic=%MainHtml%]+CRLF+;
       [Display compile progress=Yes]+CRLF+;
       [Full-text search=Yes]+CRLF+;
       [Index file=%HHK%]+CRLF+;
       [Language=%Lang%]+CRLF+;
       [Title=]+CRLF+;
       CRLF+;
       "[WINDOWS]"+CRLF+;
       'Faworites=,"%HHC%","%HHK%","%MainHtml%","",,,,,0x63520,,0x384e,[366,292,657,475],0x30000,,,,,,0'+CRLF+;
       CRLF+;
       "[FILES]"+CRLF+;
       [%files%]

   ENDPROC

ENDDEFINE

